﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		private Simpsons simpsons = new Simpsons();
		public MainPage()
		{
			InitializeComponent();
			this.Book.ItemsSource = this.simpsons;
			this.TableOfContentsListBox.ItemsSource = this.simpsons;

			this.SetLeftThumbnail();
			this.SetRightThumbnail();

			this.Book.PageChanged += new Telerik.Windows.RadRoutedEventHandler(book1_PageChanged);
		}

		void book1_PageChanged(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			this.SetRightThumbnail();
			this.SetLeftThumbnail();
		}

		private void SetRightThumbnail()
		{
			int rightPageIndex = this.Book.RightPageIndex;

			Thumbnail rightThumbnail = new Thumbnail();
			if (rightPageIndex + 1 < this.simpsons.Count)
			{
				rightThumbnail.LeftPageImageSource = this.simpsons[rightPageIndex + 1].ImageSource;
			}

			if (rightPageIndex + 2 < this.simpsons.Count)
			{
				rightThumbnail.RightPageImageSource = this.simpsons[rightPageIndex + 2].ImageSource;
			}

			this.RightPreviewButton.Content = rightThumbnail;
		}

		private void SetLeftThumbnail()
		{
			int rightPageIndex = this.Book.RightPageIndex;
			Thumbnail leftThumbnail = new Thumbnail();
			if (rightPageIndex - 2 >= 0)
			{
				leftThumbnail.RightPageImageSource = this.simpsons[rightPageIndex - 2].ImageSource;
			}
			if (rightPageIndex - 3 >= 0)
			{
				leftThumbnail.LeftPageImageSource = this.simpsons[rightPageIndex - 3].ImageSource;
			}

			this.LeftPreviewButton.Content = leftThumbnail;
		}

		private void RightArrowButton_Click(object sender, RoutedEventArgs e)
		{
			this.Book.RightPageIndex += 2;
		}

		private void LeftArrowButton_Click(object sender, RoutedEventArgs e)
		{
			this.Book.RightPageIndex -= 2;
		}

		private void TableOfContents_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			this.Book.RightPageIndex = this.TableOfContentsListBox.SelectedIndex;
		}

	}

	public class Thumbnail
	{
		public Uri LeftPageImageSource { get; set; }
		public Uri RightPageImageSource { get; set; }
	}

	public class CartoonCharacter
	{
		public string Name { get; set; }
		public Uri ImageSource { get; set; }
	}

	public class Simpsons : ObservableCollection<CartoonCharacter>
	{
		public Simpsons()
		{
			this.Add(new CartoonCharacter()
			{
				Name = "Homer",
				ImageSource = new Uri("Images/homer.jpg", UriKind.RelativeOrAbsolute)
			});

			this.Add(new CartoonCharacter()
			{
				Name = "Marge",
				ImageSource = new Uri("Images/marge.jpg", UriKind.RelativeOrAbsolute)
			});

			this.Add(new CartoonCharacter()
			{
				Name = "Bart",
				ImageSource = new Uri("Images/bart.jpg", UriKind.RelativeOrAbsolute)
			});

			this.Add(new CartoonCharacter()
			{
				Name = "Lisa",
				ImageSource = new Uri("Images/lisa.jpg", UriKind.RelativeOrAbsolute)
			});

			this.Add(new CartoonCharacter()
			{
				Name = "Maggie",
				ImageSource = new Uri("Images/maggie.jpg", UriKind.RelativeOrAbsolute)
			});

			this.Add(new CartoonCharacter()
			{
				Name = "Maggie",
				ImageSource = new Uri("Images/santaslittlehelper.jpg", UriKind.RelativeOrAbsolute)
			});
		}
	}
}
